VSphereVM [infrastructure.cluster.x-k8s.io/v1beta1]
VSphereVM is the low-level provider resource that represents the in-vCenter virtual machine backing a VSphereMachine. It is created by the provider controller, not by end users. Operators inspect it directly when troubleshooting cloning, IP allocation, or power state.
- Description
- VSphereVM is the Schema for the vspherevms API.
- Type
object
Specification
.spec
- Description
- VSphereVMSpec defines the desired state of VSphereVM.
- Type
object- Required
networktemplate
.spec.additionalDisksGiB
- Description
- AdditionalDisksGiB holds the sizes of additional disks of the virtual machine, in GiB Defaults to the eponymous property value in the template from which the virtual machine is cloned.
- Type
array
.spec.additionalDisksGiB[]
- Type
integer
.spec.bootstrapRef
- Description
- BootstrapRef is a reference to a bootstrap provider-specific resource that holds configuration details. This field is optional in case no bootstrap data is required to create a VM.
- Type
object
.spec.customVMXKeys
- Description
- CustomVMXKeys is a dictionary of advanced VMX options that can be set on VM Defaults to empty map
- Type
object
.spec.dataDisks
- Description
- DataDisks are additional disks to add to the VM that are not part of the VM's OVA template.
- Type
array
.spec.dataDisks[]
- Description
- VSphereDisk is an additional disk to add to the VM that is not part of the VM OVA template.
- Type
object- Required
namesizeGiB
.spec.network
- Description
- Network is the network configuration for this machine's VM.
- Type
object- Required
devices
.spec.network.devices
- Description
- Devices is the list of network devices used by the virtual machine.
- Type
array
.spec.network.devices[]
- Description
- NetworkDeviceSpec defines the network configuration for a virtual machine's network device.
- Type
object- Required
networkName
.spec.network.devices[].addressesFromPools
- Description
- AddressesFromPools is a list of IPAddressPools that should be assigned to IPAddressClaims. The machine's cloud-init metadata will be populated with IPAddresses fulfilled by an IPAM provider.
- Type
array
.spec.network.devices[].addressesFromPools[]
- Description
- TypedLocalObjectReference contains enough information to let you locate the typed referenced object inside the same namespace.
- Type
object- Required
kindname
.spec.network.devices[].dhcp4Overrides
- Description
- DHCP4Overrides allows for the control over several DHCP behaviors. Overrides will only be applied when the corresponding DHCP flag is set. Only configured values will be sent, omitted values will default to distribution defaults. Dependent on support in the network stack for your distribution. For more information see the netplan reference (https://netplan.io/reference#dhcp-overrides)
- Type
object
.spec.network.devices[].dhcp6Overrides
- Description
- DHCP6Overrides allows for the control over several DHCP behaviors. Overrides will only be applied when the corresponding DHCP flag is set. Only configured values will be sent, omitted values will default to distribution defaults. Dependent on support in the network stack for your distribution. For more information see the netplan reference (https://netplan.io/reference#dhcp-overrides)
- Type
object
.spec.network.devices[].ipAddrs
- Description
- IPAddrs is a list of one or more IPv4 and/or IPv6 addresses to assign to this device. IP addresses must also specify the segment length in CIDR notation. Required when DHCP4, DHCP6 and SkipIPAllocation are false.
- Type
array
.spec.network.devices[].ipAddrs[]
- Type
string
.spec.network.devices[].nameservers
- Description
- Nameservers is a list of IPv4 and/or IPv6 addresses used as DNS nameservers. Please note that Linux allows only three nameservers (https://linux.die.net/man/5/resolv.conf).
- Type
array
.spec.network.devices[].nameservers[]
- Type
string
.spec.network.devices[].routes
- Description
- Routes is a list of optional, static routes applied to the device.
- Type
array
.spec.network.devices[].routes[]
- Description
- NetworkRouteSpec defines a static network route.
- Type
object- Required
metrictovia
.spec.network.devices[].searchDomains
- Description
- SearchDomains is a list of search domains used when resolving IP addresses with DNS.
- Type
array
.spec.network.devices[].searchDomains[]
- Type
string
.spec.network.routes
- Description
- Routes is a list of optional, static routes applied to the virtual machine.
- Type
array
.spec.network.routes[]
- Description
- NetworkRouteSpec defines a static network route.
- Type
object- Required
metrictovia
.spec.pciDevices
- Description
- PciDevices is the list of pci devices used by the virtual machine.
- Type
array
.spec.pciDevices[]
- Description
- PCIDeviceSpec defines virtual machine's PCI configuration.
- Type
object
.spec.tagIDs
- Description
- TagIDs is an optional set of tags to add to an instance. Specified tagIDs must use URN-notation instead of display names.
- Type
array
.spec.tagIDs[]
- Type
string
.status
- Description
- VSphereVMStatus defines the observed state of VSphereVM.
- Type
object
.status.addresses
- Description
- Addresses is a list of the VM's IP addresses. This field is required at runtime for other controllers that read this CRD as unstructured data.
- Type
array
.status.addresses[]
- Type
string
.status.conditions
- Description
- Conditions defines current service state of the VSphereVM.
- Type
array
.status.conditions[]
- Description
- Condition defines an observation of a Cluster API resource operational state.
- Type
object- Required
lastTransitionTimestatustype
.status.network
- Description
- Network returns the network status for each of the machine's configured network interfaces.
- Type
array
.status.network[]
- Description
- NetworkStatus provides information about one of a VM's networks.
- Type
object- Required
macAddr
.status.network[].ipAddrs
- Description
- IPAddrs is one or more IP addresses reported by vm-tools.
- Type
array
.status.network[].ipAddrs[]
- Type
string
.status.v1beta2
- Description
- v1beta2 groups all the fields that will be added or modified in VSphereVM's status with the V1Beta2 version.
- Type
object
.status.v1beta2.conditions
- Description
- conditions represents the observations of a VSphereVM's current state. Known condition types are Ready, VirtualMachineProvisioned, VCenterAvailable and IPAddressClaimsFulfilled, GuestSoftPowerOffSucceeded, PCIDevicesDetached and Paused.
- Type
array
.status.v1beta2.conditions[]
- Description
- Condition contains details for one aspect of the current state of this API Resource.
- Type
object- Required
lastTransitionTimemessagereasonstatustype
API Endpoints
The following API endpoints are available:
/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vspherevmsDELETE: delete collection of VSphereVMGET: list objects of kind VSphereVMPOST: create a new VSphereVM
/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vspherevms/{name}DELETE: delete the specified VSphereVMGET: read the specified VSphereVMPATCH: partially update the specified VSphereVMPUT: replace the specified VSphereVM
/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vspherevms/{name}/statusGET: read status of the specified VSphereVMPATCH: partially update status of the specified VSphereVMPUT: replace status of the specified VSphereVM
/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vspherevms
- HTTP method
DELETE- Description
- delete collection of VSphereVM
- HTTP responses
- HTTP method
GET- Description
- list objects of kind VSphereVM
- HTTP responses
- HTTP method
POST- Description
- create a new VSphereVM
- Query parameters
- Body parameters
- HTTP responses
/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vspherevms/{name}
- HTTP method
DELETE- Description
- delete the specified VSphereVM
- Query parameters
- HTTP responses
- HTTP method
GET- Description
- read the specified VSphereVM
- HTTP responses
- HTTP method
PATCH- Description
- partially update the specified VSphereVM
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace the specified VSphereVM
- Query parameters
- Body parameters
- HTTP responses
/apis/infrastructure.cluster.x-k8s.io/v1beta1/namespaces/{namespace}/vspherevms/{name}/status
- HTTP method
GET- Description
- read status of the specified VSphereVM
- HTTP responses
- HTTP method
PATCH- Description
- partially update status of the specified VSphereVM
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace status of the specified VSphereVM
- Query parameters
- Body parameters
- HTTP responses